<?php
return [
    //'controller_auto_search' => true,
    
	'url_common_param' => true,
    
    'url_html_suffix'  => '',
    
    //自定义表单字段
    'form_fields' => [
        'admin_route_create' => [],
    ],
    
    //自定义表单数据
    'form_data' => [
        'admin_route_create' => [],
    ],
    
    //后台验证规则
    'validate_name' => [
        'admin_route_save'      => 'common/Route',
        'admin_route_update'    => 'common/Route',
        'admin_auth_save'       => 'common/Op',
        'admin_auth_update'     => 'common/Op',
        'admin_category_save'   => 'common/Term',
        'admin_category_update' => 'common/Term',
        'admin_tag_save'        => 'common/Term',
        'admin_tag_update'      => 'common/Term',
        'admin_user_save'       => 'common/User',
        'admin_user_update'     => 'common/User',
    ],
    
    //后台验证场景
    'validate_scene' => [
        'admin_category_save'   => 'save',
        'admin_category_update' => 'update',
        'admin_tag_save'        => 'save',
        'admin_tag_update'      => 'update',
        'admin_user_save'       => 'auto',
        'admin_user_update'     => 'empty',
    ],

    //别名URL唯一条件
    'slug_unique' => [
        'admin_category_save'   => ['term_type'=>['eq','category']],
        'admin_category_update' => ['term_type'=>['eq','category']],
        'admin_tag_save'        => ['term_type'=>['eq','tag']],
        'admin_tag_update'      => ['term_type'=>['eq','tag']],
        'admin_user_save'       => '',
        'admin_user_update'     => '',
    ],
    
    //后台菜单列表
    'admin_menu'       => [
        //插件
        'addon' => [],
        //顶部
        'top'   => [
            [
                'ico'     => 'fa fa-fw fa-gear',
                'title'   => 'admin_home',
                'controll'=> 'index',
                'action'  => 'index',
                'url'     => DcUrl('admin/index/index','',''),
                'order'   => 1,
            ],
            [
                'ico'     => 'fa fa-fw fa-home',
                'title'   => 'front_home',
                'controll'=> 'index',
                'action'  => 'index',
                'target'  => '_blank',
                'url'     => '../../',
                'order'   => 11,
            ],
            [
                'ico'     => 'fa fa-fw fa-sign-out',
                'title'   => 'admin_logout',
                'controll'=> 'index',
                'action'  => 'index',
                'url'     => DcUrl('admin/index/logout','',''),
                'order'   => 21,
            ],
        ],
        //配置
        'config' => [
            [
                'ico'     => 'fa fa-fw fa-gear',
                'title'   => 'op_index',
                'controll'=> 'op',
                'action'  => 'index',
                'url'     => DcUrl('admin/op/index','',''),
                'order'   => 1,
            ],
            [
                'ico'     => 'fa fa-fw fa-folder',
                'title'   => 'cache_index',
                'controll'=> 'cache',
                'action'  => 'index',
                'url'     => DcUrl('admin/cache/index','',''),
                'order'   => 11,
            ],
            [
                'ico'     => 'fa fa-fw fa-file-movie-o',
                'title'   => 'video_index',
                'controll'=> 'video',
                'action'  => 'index',
                'url'     => DcUrl('admin/video/index','',''),
                'order'   => 21,
            ],
            [
                'ico'     => 'fa fa-fw fa-upload',
                'title'   => 'upload_config',
                'controll'=> 'upload',
                'action'  => 'index',
                'url'     => DcUrl('admin/upload/index','',''),
                'order'   => 31,
            ],
        ],
        //用户
        'user' => [
            [
                'ico'     => 'fa fa-fw fa-user',
                'title'   => 'user_index',
                'controll'=> 'user',
                'action'  => 'index',
                'url'     => DcUrl('admin/user/index','',''),
                'order'   => 11,
            ],
            [
                'ico'     => 'fa fa-fw fa-filter',
                'title'   => 'auth_index',
                'controll'=> 'auth',
                'action'  => 'index',
                'url'     => DcUrl('admin/auth/index','',''),
                'order'   => 21,
            ],
        ],
        //应用
        'apply' => [
            [
                'ico'     => 'fa fa-fw fa-cloud',
                'title'   => 'apply_store',
                'controll'=> 'store',
                'action'  => 'index',
                'url'     => DcUrl('admin/store/index','',''),
                'order'   => 1,
            ],
            [
                'ico'     => 'fa fa-fw fa-archive',
                'title'   => 'apply_index',
                'controll'=> 'apply',
                'action'  => 'index',
                'url'     => DcUrl('admin/apply/index','',''),
                'order'   => 11,
            ],
            [
                'ico'     => 'fa fa-fw fa-gear',
                'title'   => 'apply_create',
                'controll'=> 'apply',
                'action'  => 'create',
                'url'     => DcUrl('admin/apply/create','',''),
                'order'   => 21,
            ],
        ],
        //系统
        'system' => [
            [
                'ico'     => 'fa fa-fw fa-wrench',
                'title'   => 'tool_index',
                'controll'=> 'tool',
                'action'  => 'index',
                'url'     => DcUrl('admin/tool/index','',''),
                'order'   => 1,
            ],
            [
                'ico'     => 'fa fa-fw fa-leaf',
                'title'   => 'category_index',
                'controll'=> 'category',
                'action'  => 'index',
                'url'     => DcUrl('admin/category/index','',''),
                'order'   => 21,
            ],
            [
                'ico'     => 'fa fa-fw fa-tag',
                'title'   => 'tag_index',
                'controll'=> 'tag',
                'action'  => 'index',
                'url'     => DcUrl('admin/tag/index','',''),
                'order'   => 31,
            ],
            [
                'ico'     => 'fa fa-fw fa-cogs',
                'title'   => 'route_index',
                'controll'=> 'route',
                'action'  => 'index',
                'url'     => DcUrl('admin/route/index','',''),
                'order'   => 61,
            ],
            [
                'ico'     => 'fa fa-fw fa-clone',
                'title'   => 'index_index',
                'controll'=> 'index',
                'action'  => 'index',
                'url'     => DcUrl('admin/index/index','',''),
                'order'   => 81,
            ],
        ],
    ]
];